// deployer main programm
// Copyright (C) 2024 Jean-Cloud
// GNU General Public License v3

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
#include "Services.h"
#include "DockerModule.h"
using namespace std;

void help(char * argv0)
{
    //temporary 
    cout << "usage: ./" << argv0 <<"action file \n with action=deploy or remove and file=path to a file or all. \n" << endl;
}

int isServiceOnServer(Service service)
//this method tests if a certain service is on the current server
//it looks into the /etc/hosts file thanks to a pipe to a separate bash process
{
    FILE *p;
    char result [100]={0};
    string cmd ="getent hosts " +service.getUsername();  
    p = popen(cmd.c_str(),"r"); 
    if( p == NULL)
    {
        cout << "Unable to verify if the service is on the server, bash process opening error." << endl;
        return -1;
    }
    fgets(result,100,p);
    pclose(p);
    if(strstr(result,"::1")!=nullptr){
        cout << "service on server" << endl;
        return 0;
    }
    cout << "service not on server" << endl;
    return 1;
}

int deployAll(){
    cout << "deploying all" <<endl;
    return 0;
}

int deployService(string service){
    cout << "deploying service" << endl;
    return 0;
}

int removeAll(){
    cout << "removing all"<<endl;
    return 0;
}

int removeService(const char* service){
    cout<< "removing service"<<endl;
    return 0;
}

int main(int argc, char *argv[])
{
    if (argc != 3){
        cout << "Invalid number of arguments. \n" << endl;
        help(argv[0]);
        exit(1);
    } else {
        if (strcmp(argv[1],"deploy")==0){
            if(strcmp(argv[2],"all")==0){
                deployAll();
            }else{
                string service = argv[2];
                deployService(service);
            }
        } else if (strcmp(argv[1],"remove")==0){
            if(strcmp(argv[2],"all")==0){
                removeAll();
            }else{
                removeService(argv[2]);
            }
        } else {
            cout << "Invalid argument. \n" << endl;
            exit(1);
        }

        //DockerModule dmodule;  
        Services services = Services();    
        isServiceOnServer(services.getServices()[0]);   
    }
    return 0;
}


